/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wigym.Kapitel410_Aufgabe1_6;

import java.util.ArrayList;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import java.io.*;
/**
 *
 * @author gk
 */
public class Kunde {
       
    KdStamm model=new KdStamm();
    JTable tabelle = new JTable (model);  
    AuftragserfassungGUI_418_Aufgabe1_6 aeg;

    public Kunde (AuftragserfassungGUI_418_Aufgabe1_6 aeg){
        this.aeg = aeg;        
    }
    public String kundeZufuegen(String kdnr, String kdname, String adresse, String bezirk ) {
        model.addRow(new String[] {kdnr, kdname, adresse, bezirk,}); 
        return ("Kunde erfasst");
   }
    public String sucheSatz (String suchname){    
        int zeile=0;
        String suNam, ausgabe;
        boolean gefunden = false;
           for (int i = 0; i < tabelle.getModel().getRowCount();i++){
               suNam = (String) tabelle.getModel().getValueAt(i, 1);
               if ( suNam.equals(suchname)){
               zeile = i;
               gefunden = true;
               break;               
           }
        }
        if (gefunden) {           
          String knr = (String)tabelle.getModel().getValueAt(zeile, 0);
          String name = (String) tabelle.getModel().getValueAt(zeile, 1);
          String strasse = (String) tabelle.getModel().getValueAt(zeile, 2);
          String bezirk = (String) tabelle.getModel().getValueAt(zeile, 3);
          ausgabe = knr +" "+name + " "+ strasse + " " +bezirk + "\n";
          return ausgabe;
        }
          else {
          return("Kunde nicht vorhanden!");
        }
    }
    
    public String kundenListe(){
        String ausgabe = "";
        for (int i = 0; i < tabelle.getModel().getRowCount();i++){
          String knr = (String)tabelle.getModel().getValueAt(i, 0);
          String name = (String) tabelle.getModel().getValueAt(i, 1);
          String strasse = (String) tabelle.getModel().getValueAt(i, 2);
          String bezirk = (String) tabelle.getModel().getValueAt(i, 3);
          ausgabe = ausgabe + knr +"\t"+name + "\t"+ strasse + "\t" +bezirk+ "\n";
      }
       return ausgabe;   
    }
    

    

    
    public void speichern(){
        model.save();
      }
    public void laden() {
        model.load();
    }
    }  // Ende

    
// Model KdStamm

    class KdStamm extends AbstractTableModel {
        
          String[]spaltName={"Nr","Firma/Name","Strasse","Bezirk"};
          String kdSatz[][] = { { "5", "Meiery", "Buchenallee 46", "1" }, 
                                { "6", "Müller", "Buschenweg 16", "2" },
                                { "7", "Henkel", "Heckenweg 26", "3" }, 
                                { "8", "Meller", "Baldurallee 23", "1" },
                                { "9", "Sahler", "Blimoosweg 36", "2" } };

    
        ArrayList<String[]>tabZeile =new ArrayList<>();
        
        public KdStamm() {
            for (String[] zeilNr:kdSatz) {
                tabZeile.add(zeilNr);
            }
        }
    public void load() {
      String fName = System.getProperty("java.io.tmpdir") + File.pathSeparator + "kunden.ser";
      File f = new File(fName);
      if (!f.exists()) {
        System.out.println("Datei existiert noch nicht. Bitte erst speichern");
        return;
      }
      try (ObjectInputStream oos = new ObjectInputStream(new FileInputStream(fName))) {

        tabZeile = (ArrayList<String[]>) oos.readObject();
        fireTableDataChanged();
        return;
      } catch (Exception ex) {
        ex.printStackTrace();
      }
      tabZeile =new ArrayList<String[]>();
    }
    
    
       public void save() {
      String fName = System.getProperty("java.io.tmpdir") + File.pathSeparator + "kunden.ser";
      try (ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(fName))) {

        oos.writeObject(tabZeile);

      } catch (Exception ex) {
        ex.printStackTrace();
      }

    }

    public void print() {
      int idx = 0;
      try (OutputStream os = new FileOutputStream(new File("print.txt"))) {
        try (PrintStream ps = new PrintStream(os)) {
          while (idx < tabZeile.size()) {
            ps.println(tabZeile.get(idx));
            idx++;
          }
        }
      } catch (IOException e) {
       
      }}
 
    
        public void addRow(String[] newData) {
              tabZeile.add(newData);
              fireTableChanged(null);
        }
        
        @Override
        public int getRowCount() {
            return tabZeile.size();
        }
        @Override
        public int getColumnCount() {
            return tabZeile.get(0).length;
        }
        @Override
        public Object getValueAt(int rowIndex, int columnIndex) {
            String[] row= tabZeile.get(rowIndex);
            return row[columnIndex];
        }
        
        @Override
        public String getColumnName(int column) {
            return spaltName[column];
        }
    }
